// Board specific configuration for Teensy

// This is for Version 2 of the  WDT board, with 4 LEDS and Switches, an Adafruit TFT display.
// a 10 segment LED bar driven by a CAT4016 and two digital pots using i2c. The standard
// setup is with the Host Port on USB and a monitor/debug port on Serial1 or with Bluetooth on Serial 5
// CAT (CI-V or RS232) on Serial4

// This file is for ARDOP

// define PLOTCONSTELLATION if you have a display attached and want a constellation display

#define PLOTCONSTELLATION
#define WDTTFT

// New WDT Board

#define HOSTPORT Serial
#define HOSTSPEED 115200
#define MONPORT Serial1
#define CATPORT Serial4
#define CATSPEED 19200
#define BTPORT Serial5

//#ifndef MONPORT
#define LOGTOHOST
//#endif

#ifdef BTPORT
#define SERIAL5SIZE 512
#define HOSTPORT2 Serial5
#endif

#define TFT
#define BARLEDS

#define HASPOTS
#define I2CPOTS
#define I2CPOTADDR 0x28

#define pttPin 6

#define LED1 8
#define LED2 26
#define LED3 25

#define SW1 27
#define SW2 28

// CAT4016 10 LED display

#define CLK 2
#define BLANK 3
#define LATCH 4
#define SIN 5

/* Bluetooth Defines for RN4678 */
//                          Pin   BT-Function
#define BT_WakeUp           A9    // In  H = Module On
#define BT_SoftwareButton   7     // In  H    L = Put Module in Standby
#define BT_Status1          A7    // Out      See table 2.3 in datasheet
#define BT_Status2          A8    // Out      See table 2.3 in datasheet
#define BT_CTS              24    // In   
#define BT_RTS              30    // Out
#define BT_PairingKey       35    // In  H    L = Force Standby
#define BT_UartRxInd        A17   // In  H    L = UART I/O In stanby mode
#define BT_LinkDropCtl      A18   // In  H    L = Drop BLE link
#define BT_InquiryCtl       A19   // In  H    L = Force BT-Classic mode
#define BT_ResetN           A20   // In  H    L = Module reset
#define BT_EAN              A6    // In  L    See table 2.1 in datasheet
#define BT_P2_4             A1    // In  H    See table 2.1 in datasheet
#define BT_P2_0             A3    // In  H    See table 2.1 in datasheet
#define BT_P3_7             29    // Out

#ifdef WDTTFT

//	Using the display on the WDT board (ILI9341)

#define ConstellationHeight 101
#define ConstellationWidth 101
#define PLOTRADIUS 47
// Set position of constellation on display
#define ConsXoffset 210
#define ConsYoffset 0
#define WHITE 0xffff
#define Tomato 0xFD20	// ILI9341_ORANGE
#define Gold Yellow
#define Lime 0x07E0 	// ILI9341_GREEN
#define Yellow 0xFFE0	// ILI9341_YELLOW  
#define Goldenrod 0xffff
#define Fuchsia 0xffff
    

#if 0
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F
#endif

#endif

#define Statsprintf MONprintf
#define WriteExceptionLog MONprintf
